module CI = Cstubs_internals

external xxhash_1_XXH32
  : _ CI.fatptr -> Unsigned.size_t -> Unsigned.uint -> Unsigned.uint
  = "xxhash_1_XXH32" 

external xxhash_2_XXH32_createState : unit -> CI.voidp
  = "xxhash_2_XXH32_createState" 

external xxhash_3_XXH32_freeState : _ CI.fatptr -> int
  = "xxhash_3_XXH32_freeState" 

external xxhash_4_XXH32_reset : _ CI.fatptr -> Unsigned.uint -> int
  = "xxhash_4_XXH32_reset" 

external xxhash_5_XXH32_update
  : _ CI.fatptr -> _ CI.fatptr -> Unsigned.size_t -> int
  = "xxhash_5_XXH32_update" 

external xxhash_6_XXH32_digest : _ CI.fatptr -> Unsigned.uint
  = "xxhash_6_XXH32_digest" 

external xxhash_7_XXH64
  : _ CI.fatptr -> Unsigned.size_t -> Unsigned.ullong -> Unsigned.ullong
  = "xxhash_7_XXH64" 

external xxhash_8_XXH64_createState : unit -> CI.voidp
  = "xxhash_8_XXH64_createState" 

external xxhash_9_XXH64_freeState : _ CI.fatptr -> int
  = "xxhash_9_XXH64_freeState" 

external xxhash_10_XXH64_reset : _ CI.fatptr -> Unsigned.ullong -> int
  = "xxhash_10_XXH64_reset" 

external xxhash_11_XXH64_update
  : _ CI.fatptr -> _ CI.fatptr -> Unsigned.size_t -> int
  = "xxhash_11_XXH64_update" 

external xxhash_12_XXH64_digest : _ CI.fatptr -> Unsigned.ullong
  = "xxhash_12_XXH64_digest" 

type 'a result = 'a
type 'a return = 'a
type 'a fn =
 | Returns  : 'a CI.typ   -> 'a return fn
 | Function : 'a CI.typ * 'b fn  -> ('a -> 'b) fn
let map_result f x = f x
let returning t = Returns t
let (@->) f p = Function (f, p)
let foreign : type a b. string -> (a -> b) fn -> (a -> b) =
  fun name t -> match t, name with
| Function (CI.Pointer _, Returns (CI.Primitive CI.Ullong)), "XXH64_digest" ->
  (fun x1 -> let CI.CPointer x2 = x1 in xxhash_12_XXH64_digest x2)
| Function
    (CI.Pointer _,
     Function
       (CI.View {CI.ty = CI.Pointer _; write = x6; _},
        Function (CI.Primitive CI.Size_t, Returns (CI.Primitive CI.Int)))),
  "XXH64_update" ->
  (fun x3 x5 x9 ->
    let CI.CPointer x8 = x6 x5 in
    let CI.CPointer x4 = x3 in let x7 = x8 in xxhash_11_XXH64_update x4 x7 x9)
| Function
    (CI.Pointer _,
     Function (CI.Primitive CI.Ullong, Returns (CI.Primitive CI.Int))),
  "XXH64_reset" ->
  (fun x10 x12 -> let CI.CPointer x11 = x10 in xxhash_10_XXH64_reset x11 x12)
| Function (CI.Pointer _, Returns (CI.Primitive CI.Int)), "XXH64_freeState" ->
  (fun x13 -> let CI.CPointer x14 = x13 in xxhash_9_XXH64_freeState x14)
| Function (CI.Void, Returns (CI.Pointer x16)), "XXH64_createState" ->
  (fun x15 -> CI.make_ptr x16 (xxhash_8_XXH64_createState x15))
| Function
    (CI.View {CI.ty = CI.Pointer _; write = x18; _},
     Function
       (CI.Primitive CI.Size_t,
        Function (CI.Primitive CI.Ullong, Returns (CI.Primitive CI.Ullong)))),
  "XXH64" ->
  (fun x17 x21 x22 ->
    let CI.CPointer x20 = x18 x17 in
    let x19 = x20 in xxhash_7_XXH64 x19 x21 x22)
| Function (CI.Pointer _, Returns (CI.Primitive CI.Uint)), "XXH32_digest" ->
  (fun x23 -> let CI.CPointer x24 = x23 in xxhash_6_XXH32_digest x24)
| Function
    (CI.Pointer _,
     Function
       (CI.View {CI.ty = CI.Pointer _; write = x28; _},
        Function (CI.Primitive CI.Size_t, Returns (CI.Primitive CI.Int)))),
  "XXH32_update" ->
  (fun x25 x27 x31 ->
    let CI.CPointer x30 = x28 x27 in
    let CI.CPointer x26 = x25 in
    let x29 = x30 in xxhash_5_XXH32_update x26 x29 x31)
| Function
    (CI.Pointer _,
     Function (CI.Primitive CI.Uint, Returns (CI.Primitive CI.Int))),
  "XXH32_reset" ->
  (fun x32 x34 -> let CI.CPointer x33 = x32 in xxhash_4_XXH32_reset x33 x34)
| Function (CI.Pointer _, Returns (CI.Primitive CI.Int)), "XXH32_freeState" ->
  (fun x35 -> let CI.CPointer x36 = x35 in xxhash_3_XXH32_freeState x36)
| Function (CI.Void, Returns (CI.Pointer x38)), "XXH32_createState" ->
  (fun x37 -> CI.make_ptr x38 (xxhash_2_XXH32_createState x37))
| Function
    (CI.View {CI.ty = CI.Pointer _; write = x40; _},
     Function
       (CI.Primitive CI.Size_t,
        Function (CI.Primitive CI.Uint, Returns (CI.Primitive CI.Uint)))),
  "XXH32" ->
  (fun x39 x43 x44 ->
    let CI.CPointer x42 = x40 x39 in
    let x41 = x42 in xxhash_1_XXH32 x41 x43 x44)
| _, s ->  Printf.ksprintf failwith "No match for %s" s


let foreign_value : type a. string -> a Ctypes.typ -> a Ctypes.ptr =
  fun name t -> match t, name with
| _, s ->  Printf.ksprintf failwith "No match for %s" s

